(function() {
	var downloadFile;

	/*
	 * ファイルダウンロード
	 */
	download = function() {
		var options = {
			url: document.getElementById("downloadUrl").value,
			timeout: 10.0,
			destination: 'cache',
		};
		applican.utilities.download(options, downloadProgress, downloadSuccess, downloadError);
	};

	/*
	 * FileEntry取得
	 */
	function downloadProgress(percent) {
		document.getElementById("dumpAreaUtilites").value = percent + "%";
	}

	/*
	 * ファイルダウンロード成功時のcallback処理
	 */
	function downloadSuccess(result) {
		var dump = "ファイルをダウンロードしました。\n";
		dump += "fullPath : " + result.fullPath;
		document.getElementById("dumpAreaUtilites").value = dump;
		document.getElementById("unzipPath").value = result.fullPath;
		downloadFile = applican.filesystem.createFileEntry(result.name, result.fullPath);
	}

	/*
	 * ファイルダウンロード失敗時のcallback処理
	 */
	function downloadError(error) {
		var dump = "downloadError\n";
		document.getElementById("dumpAreaUtilites").value = dump;
		alert(dump);
		downloadFile = null;
	}

	var unzippedFilePath;
	var unzippedDirectory;

	unzip = function () {
		if (!downloadFile) {
			return;
		}
		applican.requestFileSystem(LocalFileSystem.TEMPORARY, 0, unzipRequestFileSystemSuccess, unzipRequestFileSystemError);
	};

	function unzipRequestFileSystemSuccess(fs) {
		unzippedFilePath = fs.root.fullPath + "/unzip_dest";
		var options = {
			source: downloadFile.fullPath,
			target: unzippedFilePath,
		};

		applican.utilities.unzip(options, unzipSuccess, unzipError);
	}

	function unzipRequestFileSystemError(error) {
	}

	function unzipSuccess(result) {
		var dump = "ファイルを unzip しました。\n";
		dump += "URL : " + result.fullPath;
		document.getElementById("dumpAreaUtilites").value = dump;
		unzippedDirectory = applican.filesystem.createDirectoryEntry(result.name, result.fullPath);
	}

	function unzipError(error) {
	}

	/********************* イベント登録 *********************/
	document.addEventListener("deviceready", function() {
		// 「ファイルダウンロード」ボタン押下処理
		document.getElementById("downloadBtn").addEventListener("touchend", download, false);
		// 「ファイル Unzip」ボタン押下処理
		document.getElementById("unzipBtn").addEventListener("touchend", unzip, false);
	}, false);
})();
